
//==============================================================================
//
// Title:       Example 1
// Purpose:     First example program
//
// Created on:  8/29/2008 at 4:43:01 PM by David Judge.
// Copyright:   Anritsu. All Rights Reserved.
//
//==============================================================================

//==============================================================================
// Include files
#include <ansi_c.h>
#include <visa.h>
#include <userint.h>
#include "au37xxx.h"

ViSession session;
ViStatus checkErr (ViStatus status);
#define CHECKERR(fCal) \
    if (au37xxx_status = checkErr((fCal)), au37xxx_status < VI_SUCCESS) \
        goto Error; else


int main (int argc, char *argv[])
{
    
    ViStatus status;
    ViUInt32 read_count;
    ViStatus    au37xxx_status   = VI_SUCCESS;
    ViChar l_buffer[50];
    ViChar* p2Manf = NULL;
    ViChar* p2Model = NULL;
    ViChar* p2Ser = NULL;
    ViChar* p2Firm = NULL;
	
	printf("Example 1: Using the *IDN? Query\n\n");
    CHECKERR(au37xxx_init ("VectorStar_Test", VI_TRUE, VI_FALSE, &session));
    CHECKERR(au37xxx_write (session, "*IDN?"));
    CHECKERR(viRead (session, (ViPBuf)l_buffer, 50, &read_count));
    au37xxx_close(session);
    p2Manf = strtok(l_buffer, ",");
    p2Model = strtok(NULL, ",");
    p2Ser = strtok(NULL, ",");
    p2Firm = strtok(NULL, "\n");
    
    printf("Manufacturer: %s\nModel: %s\nSer#: %s\nFirmware: %s\n",
        p2Manf,p2Model,p2Ser,p2Firm);
    
	
    printf("\n\nHit return to exit:");
    getc(stdin);
    
    return 0;
    
Error:
    printf("\n\nDetected an Error--Hit return to exit:");
    getc(stdin);
    
    return 0;
}


ViStatus checkErr (ViStatus status)
{
    ViChar  error_message [256];
    ViChar  error_buffer [1024];
    
    if (status < VI_SUCCESS)
    {
        au37xxx_error_message (session, status, error_message);
        sprintf (error_buffer, "Primary Error: 0x%08X, %s\n", status, error_message);
        MessagePopup ("Error", error_buffer);
        au37xxx_error_query (session, error_message);
        SetWaitCursor (0);
        sprintf (error_buffer, "Instrument Error: %s\n", error_message);
        MessagePopup ("Error", error_buffer);
        au37xxx_close(session);
        session = 0;
    }
    return status;
}
